[PATCH] xfs: test that default grace periods init on first mount

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

 



There's currently a bug in how default grace periods get set up
before the very first quotacheck runs; we try to read the quota
inodes before they are populated, and so the grace periods remain
empty.  The /next/ mount fills them in.  This is a regression test
for that bug.

Signed-off-by: Eric Sandeen <sandeen@xxxxxxxxxx>
---

diff --git a/tests/xfs/995 b/tests/xfs/995
new file mode 100755
index 00000000..477855b8
--- /dev/null
+++ b/tests/xfs/995
@@ -0,0 +1,50 @@
+#! /bin/bash
+# SPDX-License-Identifier: GPL-2.0
+# Copyright (c) 2020 Red Hat, Inc.  All Rights Reserved.
+#
+# FS QA Test 995
+#
+# Regression test xfs flaw which did not report proper quota default
+# grace periods until the 2nd mount of a new filesystem with quota.
+#
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1	# failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+	cd /
+	rm -f $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+. ./common/quota
+
+# remove previous $seqres.full before test
+rm -f $seqres.full
+
+# real QA test starts here
+_supported_fs generic
+_supported_os Linux
+_require_scratch
+_require_quota
+
+_scratch_mkfs >$seqres.full 2>&1
+_qmount_option "usrquota"
+_qmount
+
+xfs_quota -x -c "state -u" $SCRATCH_MNT | grep "grace time"
+_scratch_unmount
+_qmount
+xfs_quota -x -c "state -u" $SCRATCH_MNT | grep "grace time"
+
+# success, all done
+status=0
+exit
diff --git a/tests/xfs/995.out b/tests/xfs/995.out
new file mode 100644
index 00000000..d10017d1
--- /dev/null
+++ b/tests/xfs/995.out
@@ -0,0 +1,7 @@
+QA output created by 995
+Blocks grace time: [7 days]
+Inodes grace time: [7 days]
+Realtime Blocks grace time: [7 days]
+Blocks grace time: [7 days]
+Inodes grace time: [7 days]
+Realtime Blocks grace time: [7 days]
diff --git a/tests/xfs/group b/tests/xfs/group
index 0cbd0647..235a2715 100644
--- a/tests/xfs/group
+++ b/tests/xfs/group
@@ -511,3 +511,4 @@
 511 auto quick quota
 512 auto quick acl attr
 513 auto mount
+995 auto quota quick




[Index of Archives]     [XFS Filesystem Development (older mail)]     [Linux Filesystem Development]     [Linux Audio Users]     [Yosemite Trails]     [Linux Kernel]     [Linux RAID]     [Linux SCSI]


  Powered by Linux